Hooks:PostHook(WeaponFactoryTweakData, "init", "hkpaintinit", function(self)
	
	if SystemFS:exists("assets/mod_overrides/old g3 animation") then

		self.parts.wpn_fps_ass_g3_fg_g3sd.unit = "units/mods/weapons/wpn_fps_ass_g3_pts/wpn_fps_ass_g3_fg_g3sd_old"
		self.parts.wpn_fps_ass_g3_fg_railed_afg.unit = "units/mods/weapons/wpn_fps_ass_g3_pts/wpn_fps_ass_g3_fg_railed_afg_old"

	end

	for k, used_part_id in ipairs(self.wpn_fps_ass_g3.uses_parts) do
		if self.parts[used_part_id] and self.parts[used_part_id].type and self.parts[used_part_id].pcs then
			if not table.contains(self.wpn_fps_ass_g3.default_blueprint, used_part_id) then
				if self.parts[used_part_id].type == "barrel_ext" then
					table.insert(self.parts.wpn_fps_ass_g3_fg_g3sd.forbids, used_part_id )
				end
			end
		end
	end

	for k, used_part_id in ipairs(self.wpn_fps_ass_g36.uses_parts) do
		if self.parts[used_part_id] and self.parts[used_part_id].type and self.parts[used_part_id].pcs then
			if not table.contains(self.wpn_fps_ass_g36.default_blueprint, used_part_id) then
				if self.parts[used_part_id].type == "barrel_ext" then
					table.insert(self.parts.wpn_fps_ass_g36_fg_ksk_sd.forbids, used_part_id )
				end
			end
		end
	end

	for k, used_part_id in ipairs(self.wpn_fps_snp_tti.uses_parts) do
		if self.parts[used_part_id] and self.parts[used_part_id].type and self.parts[used_part_id].pcs then
			if not table.contains(self.wpn_fps_snp_tti.default_blueprint, used_part_id) then
				if self.parts[used_part_id].type == "barrel" or
				self.parts[used_part_id].type == "foregrip" or
				self.parts[used_part_id].type == "magazine" then
					table.insert(self.parts.wpn_fps_snp_tti_body_hk417.forbids, used_part_id )
				end
			end
		end
	end

	for part_id, i in pairs(self.parts) do
		if self.parts[part_id] and self.parts[part_id].type and self.parts[part_id].type == "vertical_grip" then
			self.parts.wpn_fps_smg_mp5_fg_hk51b_railed.override[part_id] = {
				parent = "foregrip_ext",
				a_obj = "a_vg"
			}
		end
	end

	if BeardLib.Utils:FindMod("A bunch of exclusive sets") and not BeardLib.Utils:FindMod("RestorationMod") then	

		self.parts.wpn_fps_ass_g36_body_stanag.forbids = self.parts.wpn_fps_ass_g36_body_stanag.forbids or {}
		table.insert(self.parts.wpn_fps_ass_g36_body_stanag.forbids, "wpn_fps_ass_g36_fg_tfc")  

	end

	if BeardLib.Utils:FindMod("Vanilla Styled Weapon Mods") then	

		self.parts.wpn_fps_snp_tti_body_hk417.forbids = self.parts.wpn_fps_snp_tti_body_hk417.forbids or {}
		table.insert(self.parts.wpn_fps_snp_tti_body_hk417.forbids, "wpn_fps_snp_tti_b_long")  
		table.insert(self.parts.wpn_fps_snp_tti_body_hk417.forbids, "wpn_fps_snp_tti_fg_mpx")  

	end

	if BeardLib.Utils:FindMod("AR AK Mods") then	

		self.parts.wpn_fps_snp_tti_body_hk417.forbids = self.parts.wpn_fps_snp_tti_body_hk417.forbids or {}
		table.insert(self.parts.wpn_fps_snp_tti_body_hk417.forbids, "wpn_fps_upg_m4_b_victor")  
		table.insert(self.parts.wpn_fps_snp_tti_body_hk417.forbids, "wpn_fps_snp_tti_fg_victor")    
		table.insert(self.parts.wpn_fps_snp_tti_body_hk417.forbids, "wpn_fps_upg_m4_s_hera_paint")   

	end

	if BeardLib.Utils:FindMod("Weapon Texture Reworks") then	

		self.parts.wpn_fps_ass_g36_o_export.override = {
			wpn_fps_ass_g36_body_standard = {
				third_unit = "units/pd2_dlc_tng/weapons/wpn_fps_ass_g36_body_optics/wpn_third_ass_g36_body_optics",
				unit = "units/mods/weapons/wpn_fps_ass_g36_export_gsma/wpn_fps_ass_g36_body_export"		
			},
			wpn_fps_ass_g36_body_sl8 = {
				third_unit = "units/pd2_dlc_tng/weapons/wpn_fps_ass_g36_body_optics/wpn_third_ass_g36_body_optics_sl8",
				unit = "units/mods/weapons/wpn_fps_ass_g36_export_gsma/wpn_fps_ass_g36_body_export_sl8"		
			}		
		}

	end

	self.parts.wpn_fps_ass_g3_s_awp_base.visibility = {
		{
			objects = {
				g_stock = false
			}
		}
	}
	self.parts.wpn_fps_lmg_hk21_s_awp_base.visibility = {
		{
			objects = {
				g_stock = false
			}
		}
	}
	self.parts.wpn_fps_hk416_gasblock.visibility = {
		{
			objects = {
				g_barrel = false
			}
		}
	}

    self.wpn_fps_lmg_hk21.override = self.wpn_fps_lmg_hk21.override or {}	
	self.wpn_fps_lmg_hk21.override.wpn_fps_ass_g3_s_awp = {
		adds = {
			"wpn_fps_ass_g3_g_awp",
			"wpn_fps_lmg_hk21_s_awp_base"
		}
	}	
	self.wpn_fps_lmg_hk21.override.wpn_fps_ass_g3_s_adjust = {
		unit = "units/mods/weapons/wpn_fps_lmg_hk21_pts/wpn_fps_lmg_hk21_s_base"
	}	
	
end)